diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/constant-obss-pd-algorithm.h ns-3.31/src/wifi/model/constant-obss-pd-algorithm.h
--- ns-3.30.1/src/wifi/model/constant-obss-pd-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/constant-obss-pd-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -29,7 +29,7 @@
  * \brief Constant OBSS PD algorithm
  * \ingroup wifi
  *
- * This constant OBSS_PD algorithm is a simple OBSS_PD algorithm which evalutes if a receiving
+ * This constant OBSS_PD algorithm is a simple OBSS_PD algorithm which evaluates if a receiving
  * signal should be accepted or rejected based on a constant threshold.
  *
  * Once a HE preamble and its header have been received by the PHY, the ReceiveHeSig method is
@@ -37,13 +37,17 @@
  * color with the BSS color of the received preamble. If this is an OBSS frame, it compares the
  * received RSSI with its configured OBSS_PD level value. The PHY then gets reset to IDLE state
  * in case the received RSSI is lower than that constant OBSS PD level value, and is informed
- * about TX power restrictions that might be applied to the next tranmission.
+ * about TX power restrictions that might be applied to the next transmission.
  */
 class ConstantObssPdAlgorithm : public ObssPdAlgorithm
 {
 public:
   ConstantObssPdAlgorithm ();
 
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
   static TypeId GetTypeId (void);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/constant-rate-wifi-manager.cc ns-3.31/src/wifi/model/constant-rate-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/constant-rate-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/constant-rate-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -96,10 +96,10 @@
 }
 
 void
-ConstantRateWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                         double ackSnr, WifiMode ackMode, double dataSnr)
+ConstantRateWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                         double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
 }
 
 void
@@ -118,7 +118,12 @@
 ConstantRateWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  return WifiTxVector (m_dataMode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (m_dataMode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (st))), ConvertGuardIntervalToNanoSeconds (m_dataMode, GetShortGuardIntervalSupported (st), NanoSeconds (GetGuardInterval (st))), GetNumberOfAntennas (), Min (GetMaxNumberOfTransmitStreams (), GetNumberOfSupportedStreams (st)), 0, GetChannelWidthForTransmission (m_dataMode, GetChannelWidth (st)), GetAggregation (st), false);
+  uint8_t nss = Min (GetMaxNumberOfTransmitStreams (), GetNumberOfSupportedStreams (st));
+  if (m_dataMode.GetModulationClass () == WIFI_MOD_CLASS_HT)
+    {
+      nss = 1 + (m_dataMode.GetMcsValue () / 8);
+    }
+  return WifiTxVector (m_dataMode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (m_dataMode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (st))), ConvertGuardIntervalToNanoSeconds (m_dataMode, GetShortGuardIntervalSupported (st), NanoSeconds (GetGuardInterval (st))), GetNumberOfAntennas (), nss, 0, GetChannelWidthForTransmission (m_dataMode, GetChannelWidth (st)), GetAggregation (st), false);
 }
 
 WifiTxVector
@@ -128,10 +133,4 @@
   return WifiTxVector (m_ctlMode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (m_ctlMode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (st))), ConvertGuardIntervalToNanoSeconds (m_ctlMode, GetShortGuardIntervalSupported (st), NanoSeconds (GetGuardInterval (st))), 1, 1, 0, GetChannelWidthForTransmission (m_ctlMode, GetChannelWidth (st)), GetAggregation (st), false);
 }
 
-bool
-ConstantRateWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/constant-rate-wifi-manager.h ns-3.31/src/wifi/model/constant-rate-wifi-manager.h
--- ns-3.30.1/src/wifi/model/constant-rate-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/constant-rate-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -53,15 +53,14 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
-  WifiMode m_dataMode; //!< Wifi mode for unicast DATA frames
+  WifiMode m_dataMode; //!< Wifi mode for unicast Data frames
   WifiMode m_ctlMode;  //!< Wifi mode for RTS frames
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/constant-wifi-ack-policy-selector.cc ns-3.31/src/wifi/model/constant-wifi-ack-policy-selector.cc
--- ns-3.30.1/src/wifi/model/constant-wifi-ack-policy-selector.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/wifi/model/constant-wifi-ack-policy-selector.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,165 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "constant-wifi-ack-policy-selector.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ConstantWifiAckPolicySelector");
+
+NS_OBJECT_ENSURE_REGISTERED (ConstantWifiAckPolicySelector);
+
+TypeId
+ConstantWifiAckPolicySelector::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::ConstantWifiAckPolicySelector")
+    .SetParent<WifiAckPolicySelector> ()
+    .AddConstructor<ConstantWifiAckPolicySelector> ()
+    .SetGroupName("Wifi")
+    .AddAttribute ("UseExplicitBar",
+                   "Specify whether to send Block Ack Requests (if true) or use"
+                   " Implicit Block Ack Request ack policy (if false).",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&ConstantWifiAckPolicySelector::m_useExplicitBar),
+                   MakeBooleanChecker ())
+    .AddAttribute ("BaThreshold",
+                   "Immediate acknowledgment is requested upon transmission of a frame "
+                   "whose sequence number is distant at least BaThreshold multiplied "
+                   "by the transmit window size from the starting sequence number of "
+                   "the transmit window. Set to zero to request a response for every "
+                   "transmitted frame.",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&ConstantWifiAckPolicySelector::m_baThreshold),
+                   MakeDoubleChecker<double> (0.0, 1.0))
+  ;
+  return tid;
+}
+
+ConstantWifiAckPolicySelector::ConstantWifiAckPolicySelector ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+ConstantWifiAckPolicySelector::~ConstantWifiAckPolicySelector ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+ConstantWifiAckPolicySelector::UpdateTxParams (Ptr<WifiPsdu> psdu, MacLowTransmissionParameters & params)
+{
+  NS_LOG_FUNCTION (this << psdu << params);
+
+  std::set<uint8_t> tids = psdu->GetTids ();
+
+  if (tids.empty ())
+    {
+      NS_LOG_DEBUG ("No QoS Data frame in the PSDU");
+      return;
+    }
+
+  if (tids.size () > 1)
+    {
+      NS_LOG_DEBUG ("Multi-TID A-MPDUs not supported");
+      return;
+    }
+
+  Mac48Address receiver = psdu->GetAddr1 ();
+  uint8_t tid = *tids.begin ();
+
+  // Use Normal Ack if a BA agreement has not been established
+  if (!m_qosTxop->GetBaAgreementEstablished (receiver, tid))
+    {
+      params.EnableAck ();
+      return;
+    }
+
+  // If QosTxop forced the use of Block Ack QoS policy, do not make any change
+  if (params.MustSendBlockAckRequest ())
+    {
+      NS_LOG_DEBUG ("Use Block Ack policy as requested");
+      return;
+    }
+
+  // find the maximum distance from the sequence number of an MPDU included in the
+  // PSDU to the starting sequence number of the transmit window.
+  uint16_t maxDistToStartingSeq = psdu->GetMaxDistFromStartingSeq (m_qosTxop->GetBaStartingSequence (receiver, tid));
+
+  // An immediate response (Ack or Block Ack) is needed if any of the following holds:
+  // * the maximum distance between the sequence number of an MPDU to transmit
+  //   and the starting sequence number of the transmit window is greater than
+  //   or equal to the window size multiplied by the BaThreshold
+  // * no other frame belonging to this BA agreement is queued (because, in such
+  //   a case, a Block Ack is not going to be requested any time soon)
+  // * this is the initial frame of a transmission opportunity and it is not
+  //   protected by RTS/CTS (see Annex G.3 of IEEE 802.11-2016)
+  bool isResponseNeeded = (maxDistToStartingSeq >= m_baThreshold * m_qosTxop->GetBaBufferSize (receiver, tid)
+                           || m_qosTxop->PeekNextFrame (tid, receiver) == 0
+                           || (m_qosTxop->GetTxopLimit ().IsStrictlyPositive ()
+                               && m_qosTxop->GetTxopRemaining () == m_qosTxop->GetTxopLimit ()
+                               && !params.MustSendRts ()));
+
+  if (!isResponseNeeded)
+    {
+      NS_LOG_DEBUG ("A response is not needed: no ack for now, use Block Ack policy");
+      params.DisableAck ();
+      return;
+    }
+  // An immediate response is needed
+  if (maxDistToStartingSeq == 0)
+    {
+      NS_LOG_DEBUG ("Sending a single MPDU, no previous frame to ack: use Normal Ack policy");
+      NS_ASSERT (psdu->GetNMpdus () == 1);
+      params.EnableAck ();
+      return;
+    }
+  // Multiple MPDUs are being/have been sent
+  if (psdu->GetNMpdus () == 1 || m_useExplicitBar)
+    {
+      // in case of single MPDU, there are previous unacknowledged frames, thus
+      // we cannot use Implicit Block Ack Request policy, otherwise we get a
+      // normal ack as response
+      if (m_qosTxop->GetBaBufferSize (receiver, tid) > 64)
+        {
+          NS_LOG_DEBUG ("Scheduling an Extended Compressed block ack request");
+          params.EnableBlockAckRequest (BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK);
+        }
+      else
+        {
+          NS_LOG_DEBUG ("Scheduling a Compressed block ack request");
+          params.EnableBlockAckRequest (BlockAckType::COMPRESSED_BLOCK_ACK);
+        }
+      return;
+    }
+  // Implicit Block Ack Request policy
+  if (m_qosTxop->GetBaBufferSize (receiver, tid) > 64)
+    {
+      NS_LOG_DEBUG ("Implicitly requesting an Extended Compressed block ack");
+      params.EnableBlockAck (BlockAckType::EXTENDED_COMPRESSED_BLOCK_ACK);
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Implicitly requesting a Compressed block ack");
+      params.EnableBlockAck (BlockAckType::COMPRESSED_BLOCK_ACK);
+    }
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/constant-wifi-ack-policy-selector.h ns-3.31/src/wifi/model/constant-wifi-ack-policy-selector.h
--- ns-3.30.1/src/wifi/model/constant-wifi-ack-policy-selector.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/wifi/model/constant-wifi-ack-policy-selector.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,65 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef CONSTANT_WIFI_ACK_POLICY_SELECTOR_H
+#define CONSTANT_WIFI_ACK_POLICY_SELECTOR_H
+
+#include "wifi-ack-policy-selector.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * A constant ack policy selector operating based on the values of its attributes.
+ */
+class ConstantWifiAckPolicySelector : public WifiAckPolicySelector
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  ConstantWifiAckPolicySelector ();
+  virtual ~ConstantWifiAckPolicySelector();
+
+  /**
+   * Update the transmission parameters related to the acknowledgment policy for
+   * the given PSDU. This method is typically called by the MPDU aggregator when
+   * trying to aggregate another MPDU to the current A-MPDU. In fact, the
+   * AckPolicySelector may switch to a different acknowledgment policy when a
+   * new MPDU is aggregated to an A-MPDU.
+   * Note that multi-TID A-MPDUs are currently not supported by this method.
+   *
+   * \param psdu the given PSDU.
+   * \param params the MacLow parameters to update.
+   */
+  virtual void UpdateTxParams (Ptr<WifiPsdu> psdu, MacLowTransmissionParameters & params);
+
+private:
+  bool m_useExplicitBar; //!< true for sending BARs, false for using Implicit BAR ack policy
+  double m_baThreshold;  //!< Threshold to determine when a BlockAck must be requested
+};
+
+} //namespace ns3
+
+#endif /* CONSTANT_WIFI_ACK_POLICY_SELECTOR_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ctrl-headers.cc ns-3.31/src/wifi/model/ctrl-headers.cc
--- ns-3.30.1/src/wifi/model/ctrl-headers.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ctrl-headers.cc	2020-06-27 17:38:30.000000000 -0700
@@ -318,7 +318,7 @@
         size += (2 + 32);
         break;
       case MULTI_TID_BLOCK_ACK:
-        size += (2 + 2 + 8) * (m_tidInfo + 1); //Multi-tid block ack
+        size += (2 + 2 + 8) * (m_tidInfo + 1); //Multi-TID block ack
         break;
       default:
         NS_FATAL_ERROR ("Invalid BA type");
@@ -627,7 +627,7 @@
       case COMPRESSED_BLOCK_ACK:
       case EXTENDED_COMPRESSED_BLOCK_ACK:
         /* We can ignore this...compressed block ack doesn't support
-           acknowledgement of single fragments */
+           acknowledgment of single fragments */
         break;
       case MULTI_TID_BLOCK_ACK:
         NS_FATAL_ERROR ("Multi-tid block ack is not supported.");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ctrl-headers.h ns-3.31/src/wifi/model/ctrl-headers.h
--- ns-3.30.1/src/wifi/model/ctrl-headers.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ctrl-headers.h	2020-06-27 17:38:30.000000000 -0700
@@ -28,15 +28,15 @@
 
 /**
  * \ingroup wifi
- * \brief Headers for Block ack request.
+ * \brief Headers for BlockAckRequest.
  *
- *  802.11n standard includes three types of block ack:
- *    - Basic block ack (unique type in 802.11e)
- *    - Compressed block ack
- *    - Multi-TID block ack
- *  For now only basic block ack and compressed block ack
+ *  802.11n standard includes three types of BlockAck:
+ *    - Basic BlockAck (unique type in 802.11e)
+ *    - Compressed BlockAck
+ *    - Multi-TID BlockAck
+ *  For now only basic BlockAck and compressed BlockAck
  *  are supported.
- *  Basic block ack is also default variant.
+ *  Basic BlockAck is also default variant.
  */
 class CtrlBAckRequestHeader : public Header
 {
@@ -55,21 +55,21 @@
   uint32_t Deserialize (Buffer::Iterator start);
 
   /**
-   * Enable or disable HT immediate ACK.
+   * Enable or disable HT immediate Ack.
    *
-   * \param immediateAck enable or disable HT immediate ACK
+   * \param immediateAck enable or disable HT immediate Ack
    */
   void SetHtImmediateAck (bool immediateAck);
   /**
-   * Set the block ACK type.
+   * Set the block ack type.
    *
-   * \param type
+   * \param type the BA type
    */
   void SetType (BlockAckType type);
   /**
    * Set Traffic ID (TID).
    *
-   * \param tid
+   * \param tid the TID
    */
   void SetTidInfo (uint8_t tid);
   /**
@@ -81,16 +81,16 @@
   void SetStartingSequence (uint16_t seq);
 
   /**
-   * Check if the current ACK policy is immediate.
+   * Check if the current Ack Policy is immediate.
    *
-   * \return true if the current ACK policy is immediate,
+   * \return true if the current Ack Policy is immediate,
    *         false otherwise
    */
   bool MustSendHtImmediateAck (void) const;
   /**
-   * Return the block ACK type ID.
+   * Return the Block Ack type ID.
    *
-   * \return type
+   * \return the BA type
    */
   BlockAckType GetType (void) const;
   /**
@@ -106,32 +106,32 @@
    */
   uint16_t GetStartingSequence (void) const;
   /**
-   * Check if the current ACK policy is basic
-   * (i.e. not multiple TID and not compressed ACK).
+   * Check if the current Ack Policy is Basic Block Ack
+   * (i.e. not multi-TID nor compressed).
    *
-   * \return true if the current ACK policy is basic,
+   * \return true if the current Ack Policy is Basic Block Ack,
    *         false otherwise
    */
   bool IsBasic (void) const;
   /**
-   * Check if the current ACK policy is compressed ACK
-   * and not multiple TID.
+   * Check if the current Ack Policy is Compressed Block Ack
+   * and not multi-TID.
    *
-   * \return true if the current ACK policy is compressed ACK,
+   * \return true if the current Ack Policy is Compressed Block Ack,
    *         false otherwise
    */
   bool IsCompressed (void) const;
   /**
-   * Check if the current BA policy is extended compressed block ACK.
+   * Check if the current Ack Policy is Extended Compressed Block Ack.
    *
-   * \return true if the current BA policy is extended compressed block ACK,
+   * \return true if the current Ack Policy is Extended Compressed Block Ack,
    *         false otherwise
    */
   bool IsExtendedCompressed (void) const;
   /**
-   * Check if the current ACK policy has multiple TID.
+   * Check if the current Ack Policy has Multi-TID Block Ack.
    *
-   * \return true if the current ACK policy has multiple TID,
+   * \return true if the current Ack Policy has Multi-TID Block Ack,
    *         false otherwise
    */
   bool IsMultiTid (void) const;
@@ -149,46 +149,46 @@
    * Set the starting sequence control with the given
    * sequence control value
    *
-   * \param seqControl
+   * \param seqControl the sequence control value
    */
   void SetStartingSequenceControl (uint16_t seqControl);
   /**
-   * Return the Block ACK control.
+   * Return the Block Ack control.
    *
-   * \return the Block ACK control
+   * \return the Block Ack control
    */
   uint16_t GetBarControl (void) const;
   /**
-   * Set the Block ACK control.
+   * Set the Block Ack control.
    *
-   * \param bar
+   * \param bar the BAR control value
    */
   void SetBarControl (uint16_t bar);
 
   /**
-   * The lsb bit of the BAR control field is used only for the
+   * The LSB bit of the BAR control field is used only for the
    * HT (High Throughput) delayed block ack configuration.
-   * For now only non HT immediate block ack is implemented so this field
+   * For now only non HT immediate BlockAck is implemented so this field
    * is here only for a future implementation of HT delayed variant.
    */
-  bool m_barAckPolicy;    ///< bar ack policy
+  bool m_barAckPolicy;    ///< BAR Ack Policy
   BlockAckType m_baType;  ///< BA type
   uint16_t m_tidInfo;     ///< TID info
-  uint16_t m_startingSeq; ///< starting seq
+  uint16_t m_startingSeq; ///< starting sequence number
 };
 
 
 /**
  * \ingroup wifi
- * \brief Headers for Block ack response.
+ * \brief Headers for BlockAck response.
  *
- *  802.11n standard includes three types of block ack:
- *    - Basic block ack (unique type in 802.11e)
- *    - Compressed block ack
- *    - Multi-TID block ack
- *  For now only basic block ack and compressed block ack
+ *  802.11n standard includes three types of BlockAck:
+ *    - Basic BlockAck (unique type in 802.11e)
+ *    - Compressed BlockAck
+ *    - Multi-TID BlockAck
+ *  For now only basic BlockAck and compressed BlockAck
  *  are supported.
- *  Basic block ack is also default variant.
+ *  Basic BlockAck is also default variant.
  */
 class CtrlBAckResponseHeader : public Header
 {
@@ -207,21 +207,21 @@
   uint32_t Deserialize (Buffer::Iterator start);
 
   /**
-   * Enable or disable HT immediate ACK.
+   * Enable or disable HT immediate Ack.
    *
-   * \param immediateAck enable or disable HT immediate ACK
+   * \param immediateAck enable or disable HT immediate Ack
    */
   void SetHtImmediateAck (bool immediateAck);
   /**
-   * Set the block ACK type.
+   * Set the block ack type.
    *
-   * \param type
+   * \param type the BA type
    */
   void SetType (BlockAckType type);
   /**
    * Set Traffic ID (TID).
    *
-   * \param tid
+   * \param tid the TID
    */
   void SetTidInfo (uint8_t tid);
   /**
@@ -233,14 +233,14 @@
   void SetStartingSequence (uint16_t seq);
 
   /**
-   * Check if the current ACK policy is immediate.
+   * Check if the current Ack Policy is immediate.
    *
-   * \return true if the current ACK policy is immediate,
+   * \return true if the current Ack Policy is immediate,
    *         false otherwise
    */
   bool MustSendHtImmediateAck (void) const;
   /**
-   * Return the block ACK type ID.
+   * Return the block ack type ID.
    *
    * \return type
    */
@@ -258,30 +258,30 @@
    */
   uint16_t GetStartingSequence (void) const;
   /**
-   * Check if the current BA policy is basic block ACK.
+   * Check if the current BA policy is Basic Block Ack.
    *
-   * \return true if the current BA policy is basic block ACK,
+   * \return true if the current BA policy is Basic Block Ack,
    *         false otherwise
    */
   bool IsBasic (void) const;
   /**
-   * Check if the current BA policy is compressed block ACK.
+   * Check if the current BA policy is Compressed Block Ack.
    *
-   * \return true if the current BA policy is compressed block ACK,
+   * \return true if the current BA policy is Compressed Block Ack,
    *         false otherwise
    */
   bool IsCompressed (void) const;
   /**
-   * Check if the current BA policy is extended compressed block ACK.
+   * Check if the current BA policy is Extended Compressed Block Ack.
    *
-   * \return true if the current BA policy is extended compressed block ACK,
+   * \return true if the current BA policy is Extended Compressed Block Ack,
    *         false otherwise
    */
   bool IsExtendedCompressed (void) const;
   /**
-   * Check if the current BA policy is multi-TID block ACK.
+   * Check if the current BA policy is Multi-TID Block Ack.
    *
-   * \return true if the current BA policy is multi-TID block ACK,
+   * \return true if the current BA policy is Multi-TID Block Ack,
    *         false otherwise
    */
   bool IsMultiTid (void) const;
@@ -290,34 +290,34 @@
    * Set the bitmap that the packet with the given sequence
    * number was received.
    *
-   * \param seq
+   * \param seq the sequence number
    */
   void SetReceivedPacket (uint16_t seq);
   /**
    * Set the bitmap that the packet with the given sequence
    * number and fragment number was received.
    *
-   * \param seq
-   * \param frag
+   * \param seq the sequence number
+   * \param frag the fragment number
    */
   void SetReceivedFragment (uint16_t seq, uint8_t frag);
   /**
    * Check if the packet with the given sequence number
-   * was ACKed in this Block ACK response.
+   * was acknowledged in this BlockAck response.
    *
-   * \param seq
+   * \param seq the sequence number
    * \return true if the packet with the given sequence number
-   *         was ACKed in this Block ACK response, false otherwise
+   *         was ACKed in this BlockAck response, false otherwise
    */
   bool IsPacketReceived (uint16_t seq) const;
   /**
    * Check if the packet with the given sequence number
-   * and fragment number was ACKed in this Block ACK response.
+   * and fragment number was acknowledged in this BlockAck response.
    *
-   * \param seq
-   * \param frag
+   * \param seq the sequence number
+   * \param frag the fragment number
    * \return true if the packet with the given sequence number
-   *         and sequence number was ACKed in this Block ACK response,
+   *         and sequence number was acknowledged in this BlockAck response,
    *         false otherwise
    */
   bool IsFragmentReceived (uint16_t seq, uint8_t frag) const;
@@ -332,26 +332,25 @@
    * Set the starting sequence control with the given
    * sequence control value
    *
-   * \param seqControl
+   * \param seqControl the raw sequence control value
    */
   void SetStartingSequenceControl (uint16_t seqControl);
   /**
-   * Return the bitmap from the block ACK response header.
+   * Return the bitmap from the BlockAck response header.
    *
-   * \return the bitmap from the block ACK response header
+   * \return the bitmap from the BlockAck response header
    */
-
   const uint16_t* GetBitmap (void) const;
   /**
-   * Return the compressed bitmap from the block ACK response header.
+   * Return the compressed bitmap from the BlockAck response header.
    *
-   * \return the compressed bitmap from the block ACK response header
+   * \return the compressed bitmap from the BlockAck response header
    */
   uint64_t GetCompressedBitmap (void) const;
   /**
-   * Return the extended compressed bitmap from the block ACK response header.
+   * Return the extended compressed bitmap from the BlockAck response header.
    *
-   * \return the extended compressed bitmap from the block ACK response header
+   * \return the extended compressed bitmap from the BlockAck response header
    */
   const uint64_t* GetExtendedCompressedBitmap (void) const;
 
@@ -363,29 +362,29 @@
 
 private:
   /**
-   * Return the block ACK control.
+   * Return the Block Ack control.
    *
-   * \return the block ACK control
+   * \return the Block Ack control
    */
   uint16_t GetBaControl (void) const;
   /**
-   * Set the block ACK control.
+   * Set the Block Ack control.
    *
-   * \param bar
+   * \param ba the BA control to set
    */
-  void SetBaControl (uint16_t bar);
+  void SetBaControl (uint16_t ba);
 
   /**
    * Serialize bitmap to the given buffer.
    *
-   * \param start
+   * \param start the iterator
    * \return Buffer::Iterator to the next available buffer
    */
   Buffer::Iterator SerializeBitmap (Buffer::Iterator start) const;
   /**
    * Deserialize bitmap from the given buffer.
    *
-   * \param start
+   * \param start the iterator
    * \return Buffer::Iterator to the next available buffer
    */
   Buffer::Iterator DeserializeBitmap (Buffer::Iterator start);
@@ -411,26 +410,26 @@
    *
    * \param seq the sequence number
    *
-   * \return
+   * \return true if the sequence number is concerned by the bitmap
    */
   bool IsInBitmap (uint16_t seq) const;
 
   /**
-   * The lsb bit of the BA control field is used only for the
+   * The LSB bit of the BA control field is used only for the
    * HT (High Throughput) delayed block ack configuration.
    * For now only non HT immediate block ack is implemented so this field
    * is here only for a future implementation of HT delayed variant.
    */
-  bool m_baAckPolicy;     ///< BA ack policy
+  bool m_baAckPolicy;     ///< BA Ack Policy
   BlockAckType m_baType;  ///< BA type
   uint16_t m_tidInfo;     ///< TID info
-  uint16_t m_startingSeq; ///< starting seq
+  uint16_t m_startingSeq; ///< starting sequence number
 
   union
   {
-    uint16_t m_bitmap[64]; ///< the block ack bitmap
-    uint64_t m_compressedBitmap; ///< the compressed block ack bitmap
-    uint64_t m_extendedCompressedBitmap[4]; ///< the extended compressed block ack bitmap
+    uint16_t m_bitmap[64]; ///< the basic BlockAck bitmap
+    uint64_t m_compressedBitmap; ///< the compressed BlockAck bitmap
+    uint64_t m_extendedCompressedBitmap[4]; ///< the extended compressed BlockAck bitmap
   } bitmap; ///< bitmap union type
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/dsss-error-rate-model.cc ns-3.31/src/wifi/model/dsss-error-rate-model.cc
--- ns-3.30.1/src/wifi/model/dsss-error-rate-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/dsss-error-rate-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -68,7 +68,7 @@
   return std::min (1.0, std::pow (1.0 - sep, nbits / 4.0));
 #else
   NS_LOG_WARN ("Running a 802.11b CCK Matlab model less accurate than GSL model");
-  //The matlab model
+  //The Matlab model
   double ber;
   if (sinr > WLAN_SIR_PERFECT)
     {
@@ -80,7 +80,7 @@
     }
   else
     {
-      //fitprops.coeff from matlab berfit
+      //fitprops.coeff from Matlab berfit
       double a1 = 5.3681634344056195e-001;
       double a2 = 3.3092430025608586e-003;
       double a3 = 4.1654372361004000e-001;
@@ -103,7 +103,7 @@
   return std::min (1.0, std::pow (1.0 - sep, nbits / 8.0));
 #else
   NS_LOG_WARN ("Running a 802.11b CCK Matlab model less accurate than GSL model");
-  //The matlab model
+  //The Matlab model
   double ber;
   if (sinr > WLAN_SIR_PERFECT)
     {
@@ -115,7 +115,7 @@
     }
   else
     {
-      //fitprops.coeff from matlab berfit
+      //fitprops.coeff from Matlab berfit
       double a1 = 7.9056742265333456e-003;
       double a2 = -1.8397449399176360e-001;
       double a3 = 1.0740689468707241e+000;
